"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var handlePlusTagFilter = [R.prop("plusTag"), function (_ref) {
	var plusTag = _ref.plusTag;
	return function (_ref2) {
		var tags = _ref2.tags;
		return (tags || []).includes(plusTag);
	};
}];

var handleProjectFilter = [R.propEq("prop", "project"), function (_ref3) {
	var value = _ref3.value;
	return function (_ref4) {
		var project = _ref4.project;
		return (project || "").includes(value);
	};
}];

var defaultPropValueFilter = [R.T, function (_ref5) {
	var prop = _ref5.prop,
	    value = _ref5.value;
	return function (task) {
		return task[prop] === value;
	};
}];

var handlePropValueFilter = [R.both(R.prop("prop"), R.prop("value")), R.cond([handleProjectFilter, defaultPropValueFilter])];

var handleIdFilter = [R.prop("int"), function (_ref6) {
	var int = _ref6.int;
	return function (_ref7) {
		var id = _ref7.id;
		return int === id;
	};
}];

var filterByCLICommands = R.pipe(R.map(R.cond([handlePlusTagFilter, handlePropValueFilter, handleIdFilter])), R.filter(Boolean), R.when(R.propEq("length", 0), R.always([R.T])), R.anyPass);

exports.default = filterByCLICommands;