"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

var _jecJask = require("jec-jask");

var _modifyByCLICommands = require("./modifyByCLICommands");

var _modifyByCLICommands2 = _interopRequireDefault(_modifyByCLICommands);

var _filterByCLICommands = require("./filterByCLICommands");

var _filterByCLICommands2 = _interopRequireDefault(_filterByCLICommands);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var generateModifyActions = function generateModifyActions(_ref) {
	var state = _ref.state,
	    filter = _ref.filter,
	    modifications = _ref.modifications;

	var filterUUIDs = (0, _filterByCLICommands2.default)(filter);
	var applyToUUIDs = (0, _jecJask.collateAllObjects)(state).filter(filterUUIDs).map(R.prop("uuid"));

	var generateActions = R.pipe((0, _modifyByCLICommands2.default)(state), R.map(function (action) {
		return applyToUUIDs.map(function (objId) {
			return (0, _extends3.default)({}, action, {
				objId: objId
			});
		});
	}), R.flatten);

	return {
		actions: generateActions(modifications),
		filterForRender: filterUUIDs
	};
};

exports.default = generateModifyActions;