"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

var _v = require("uuid/v4");

var _v2 = _interopRequireDefault(_v);

var _parseDateTime = require("./parseDateTime");

var _parseDateTime2 = _interopRequireDefault(_parseDateTime);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parseTimeShortcutValues = [R.pipe(R.prop("prop"), R.contains(R.__, ["due", "wait", "stop", "start"])), R.pipe(R.over(R.lensProp("value"), _parseDateTime2.default), R.over(R.lensProp("type"), R.defaultTo("SET_PROP")))];

var parseRecurShortcutValues = [R.propEq("prop", "recur"), R.pipe(R.over(R.lensProp("value"), _parseDateTime.parseRecur), R.over(R.lensProp("type"), R.defaultTo("SET_PROP")))];

var parsePriorityValues = [R.propEq("prop", "priority"), R.pipe(R.over(R.lensProp("value"), R.toUpper), R.over(R.lensProp("type"), R.defaultTo("SET_PROP")))];

var generateProjectActions = function generateProjectActions(_ref) {
	var projects = _ref.projects;
	return [R.propEq("prop", "project"), R.pipe(R.over(R.lensProp("value"), R.split(".")), function (_ref2) {
		var value = _ref2.value,
		    rest = (0, _objectWithoutProperties3.default)(_ref2, ["value"]);

		var keyValuePairs = R.toPairs(projects);

		var actions = [];
		var prevSubProjectId = undefined;

		var _loop = function _loop(subProjectName) {
			var _ref3 = R.find(function (_ref5) {
				var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
				    id = _ref6[0],
				    _ref6$ = _ref6[1],
				    name = _ref6$.name,
				    parent = _ref6$.parent;

				return name === subProjectName && parent === prevSubProjectId;
			}, keyValuePairs) || [],
			    _ref4 = (0, _slicedToArray3.default)(_ref3, 2),
			    existantProjectId = _ref4[0],
			    _ref4$ = _ref4[1];

			_ref4$ = _ref4$ === undefined ? {} : _ref4$;
			var existantProjectName = _ref4$.name,
			    existantProjectParent = _ref4$.parent;


			if (existantProjectId) {
				prevSubProjectId = existantProjectId;
				return "continue";
			} else {
				var projectId = (0, _v2.default)();
				actions.push({
					type: "SET_PROJECT",
					name: subProjectName,
					parent: prevSubProjectId,
					projectId: projectId
				});
				prevSubProjectId = projectId;
				return "continue";
			}
		};

		var _iteratorNormalCompletion = true;
		var _didIteratorError = false;
		var _iteratorError = undefined;

		try {
			for (var _iterator = value[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
				var subProjectName = _step.value;

				var _ret = _loop(subProjectName);

				if (_ret === "continue") continue;
			}
		} catch (err) {
			_didIteratorError = true;
			_iteratorError = err;
		} finally {
			try {
				if (!_iteratorNormalCompletion && _iterator.return) {
					_iterator.return();
				}
			} finally {
				if (_didIteratorError) {
					throw _iteratorError;
				}
			}
		}

		actions.push({
			type: "SET_PROP",
			prop: "project",
			value: prevSubProjectId
		});

		return actions;
	})];
};

var handlePropValueModification = function handlePropValueModification(state) {
	return R.pipe(R.cond([parseTimeShortcutValues, parseRecurShortcutValues, parsePriorityValues, generateProjectActions(state), [R.T, R.over(R.lensProp("type"), R.defaultTo("SET_PROP"))]]));
};

var handlePlusTagModification = function handlePlusTagModification(_ref7) {
	var plusTag = _ref7.plusTag;
	return {
		type: "ADD_TAG_TO_OBJ",
		tag: plusTag
	};
};

var modifyByCLICommand = function modifyByCLICommand(state) {
	return R.pipe(R.map(R.pipe(R.cond([[R.both(R.prop("prop"), R.prop("value")), handlePropValueModification(state)], [R.prop("plusTag"), handlePlusTagModification]]))), R.flatten, R.filter(Boolean));
};

exports.default = modifyByCLICommand;